Unit ZCPQLI_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function ZCPQLI(NN :Integer; var PT :Array of Real;
                var Q :Array of Real): Real;

implementation

function ZCPQLI(NN :Integer; var PT :Array of Real;
                var Q :Array of Real): Real;
var
N,I :Integer;
X,XM,F,DX,DF :Real;
const
ZERO :Real = 0.0;
PT1 :Real = 0.1;
PTOO5 :Real = 0.005;
label
_1,_2,_3,_4,_5,_6,_7;
begin
{ Result -    ZCPQLI  FORTRANe }
PT[NN-1] := -PT[NN-1];
N := NN-1;
X := Exp((Ln(-PT[NN-1])-Ln(PT[0]))/(N));
if ( PT[N-1] = ZERO ) 
 then goto _1;
XM := -PT[NN-1]/PT[N-1];
if ( XM < X ) 
 then X := XM;
_1:
XM := X*PT1;
F := PT[0];
for I:=2 to NN do
 begin
  F := F*XM+PT[I-1];
_2:
 end;
if ( F <= ZERO ) 
 then goto _3;
X := XM;
goto _1;
_3:
DX := X;
_4:
if ( Abs(DX/X) <= PTOO5 ) 
 then goto _7;
Q[0] := PT[0];
for I:=2 to NN do
 begin
  Q[I-1] := Q[I-2]*X+PT[I-1];
_5:
 end;
F := Q[NN-1];
DF := Q[0];
for I:=2 to N do
 begin
  DF := DF*X+Q[I-1];
_6:
 end;
DX := F/DF;
X := X-DX;
goto _4;
_7:
Result := X;
exit;
end;

end.
