Unit ZP11C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZCPQLM_p, ZCPQLK_p, ZCPQLB_p, ZCPQLC_p, UTZP10_p, ZCPQLL_p,
ZCPQLJ_p, ZCPQLI_p;

procedure ZP11C(NP :Integer; var A :Array of Real;
                var ROOT :Array of Real; var RAB :Array of Real;
                var IERR :Integer);

implementation

procedure ZP11C(NP :Integer; var A :Array of Real;
                var ROOT :Array of Real; var RAB :Array of Real;
                var IERR :Integer);
var
NDEG2,NDEG,I,J,NN2,J1,II,I1,I2,I3,I4,ICNT1,ICNT2,INX,INXI,NPI,
   N2 :Integer;
XX,YY,COSR,SINR,BND,REPSP,RADIX,XXX,ZR,ZI :Real;
CONV :Boolean;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
TWO :Real = 2.0;
SYS029 :Real = 0.70710678118654752440084436210485;
SYS030 :Real = 1.4142135623730950488016887242097;
SYS059 :Real = 3.4E38; //  Delphi>3
CON1 :Real = 10;
label
_5,_10,_15,_20,_25,_30,_35,_40,_45,_50,_55,_60,_65,_70,_75,_80,_9000,
_9005;
begin
_PP11C.elm1 := NP+1;
_PP11C.elm2 := _PP11C.elm1+_PP11C.elm1;
_PP11C.elm3 := _PP11C.elm2+_PP11C.elm1;
_PP11C.elm4 := _PP11C.elm3+_PP11C.elm1;
_PP11C.elm5 := _PP11C.elm4+_PP11C.elm1;
_PP11C.elm6 := _PP11C.elm5+_PP11C.elm1;
_PP11C.elm7 := _PP11C.elm6+_PP11C.elm1;
_PP11C.elm8 := _PP11C.elm7+_PP11C.elm1;
_PP11C.elm9 := _PP11C.elm8+_PP11C.elm1;
_PP11C.elm10 := _PP11C.elm9+_PP11C.elm1;
NDEG2 := NP+NP;
NDEG := NP;
IERR := 0;
if ( NP < 1 )
 then goto _80;
ZCPQLM(_PCPQLN.elm9,_PCPQLN.elm10,REPSP,RADIX);
_PCPQLN.elm7 := _PCPQLN.elm9;
_PCPQLN.elm8 := TWO*SYS030*_PCPQLN.elm9;
XX := SYS029;
YY := -XX;
I := 1;
J := 1;
COSR := -0.06975647;
SINR := 0.9975641;
_PCPQLN.elm11 := NDEG+1;
NN2 := _PCPQLN.elm11+_PCPQLN.elm11;
if ( A[NN2-1] <> ZERO ) or ( A[NN2-2] <> ZERO )
 then goto _5;
IERR := 66;
goto _9000;
_5:
if ( A[J-1] <> ZERO ) or ( A[J+0] <> ZERO )
 then goto _10;
ROOT[I-1] := ZERO;
J1 := I+NP;
_PCPQLN.elm11 := _PCPQLN.elm11-1;
ROOT[J1-1] := ZERO;
J := J+2;
I := I+1;
if ( I = _PP11C.elm1 )
 then goto _9005;
goto _5;
_10:
for I:=1 to _PCPQLN.elm11 do
 begin
  II := I+I;
  I1 := _PCPQLN.elm11-I+1;
  I2 := _PCPQLN.elm11-I+1+_PP11C.elm1;
  I3 := II+J-2;
  I4 := I3+1;
  RAB[I1-1] := A[I3-1];
  RAB[I2-1] := A[I4-1];
  I3 := _PP11C.elm8+I;
  I4 := _PP11C.elm1+I;
  RAB[I3-1] := ZCPQLL(RAB[I-1],RAB[I4-1]);
_15:
 end;
BND := ZCPQLJ(_PCPQLN.elm11,RAB[_PP11C.elm8+0],_PCPQLN.elm9,_PCPQLN.elm10,REPSP,RADIX);
if ( BND = ONE )
 then goto _25;
for I:=1 to _PCPQLN.elm11 do
 begin
  I1 := _PP11C.elm1+I;
  RAB[I-1] := BND*RAB[I-1];
  RAB[I1-1] := BND*RAB[I1-1];
_20:
 end;
_25:
if ( _PCPQLN.elm11 > 2 )
 then goto _30;
ZCPQLK(-RAB[1],-RAB[_PP11C.elm1+1],RAB[0],RAB[_PP11C.elm1+0],
     ROOT[NDEG-1],ROOT[NDEG2-1]);
goto _60;
_30:
for I:=1 to _PCPQLN.elm11 do
 begin
  I1 := _PP11C.elm8+I;
  I2 := _PP11C.elm1+I;
  RAB[I1-1] := ZCPQLL(RAB[I-1],RAB[I2-1]);
_35:
 end;
BND := ZCPQLI(_PCPQLN.elm11,RAB[_PP11C.elm8+0],RAB[_PP11C.elm9+0]);
for ICNT1:=1 to 2 do
 begin
  ZCPQLB(5,RAB);
  for ICNT2:=1 to 9 do
   begin
    XXX := COSR*XX-SINR*YY;
    YY := SINR*XX+COSR*YY;
    XX := XXX;
    _PCPQLN.elm1 := BND*XX;
    _PCPQLN.elm2 := BND*YY;
    ZCPQLC(Trunc(CON1*ICNT2),ZR,ZI,CONV,RAB);
    if ( not CONV )
     then goto _45;
    INX := NDEG+2-_PCPQLN.elm11;
    INXI := INX+NDEG;
    ROOT[INX-1] := ZR;
    ROOT[INXI-1] := ZI;
    _PCPQLN.elm11 := _PCPQLN.elm11-1;
    for I:=1 to _PCPQLN.elm11 do
     begin
      I1 := _PP11C.elm1+I;
      I2 := _PP11C.elm4+I;
      I3 := _PP11C.elm5+I;
      RAB[I-1] := RAB[I2-1];
      RAB[I1-1] := RAB[I3-1];
_40:
     end;
    goto _25;
_45:
_50:
   end;
_55:
 end;
IERR := 67;
_60:
for I:=1 to NDEG do
 begin
  NPI := NDEG+I;
  I1 := _PP11C.elm1+I;
  RAB[I1-1] := ROOT[NPI-1];
_65:
 end;
N2 := NDEG+NDEG;
J1 := NDEG+_PP11C.elm1;
J := NDEG;
for I:=1 to NDEG do
 begin
  ROOT[N2-2] := ROOT[J-1];
  ROOT[N2-1] := RAB[J1-1];
  N2 := N2-2;
  J := J-1;
  J1 := J1-1;
_70:
 end;
if ( IERR = 0 )
 then goto _9005;
N2 := 2*(NDEG-_PCPQLN.elm11)+3;
_PP11C.elm1 := _PCPQLN.elm11-1;
for I:=1 to _PP11C.elm1 do
 begin
  ROOT[N2-1] := SYS059;
  ROOT[N2+0] := SYS059;
  N2 := N2+2;
_75:
 end;
goto _9000;
_80:
IERR := 65;
_9000:
if ( IERR <> 0 )
 then UTZP10(IERR,111);
_9005:
end;

end.
